%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 2
%global version_minor 4
%global version_micro 0
%global serial 27
%global commitid 495496e91c756fada2ca6d2ed0e12f9681e70409

%define with_src_zip 1

%{?scl:%scl_package mod_md}
%{!?scl:%global pkg_name %{name}}
%define scldir /opt/rh/jbcs-httpd24/root

Name:           %{?scl_prefix}mod_md
Version:        2.4.0
Release:        %{serial}%{?dist}
Summary:        Certificate provisioning using ACME for the Apache HTTP Server
License:        ASL 2.0
URL:            https://icing.github.io/mod_md/
Group:          Internet/WWW/Servers
Source0:        %{pkg_name}-%{commitid}.tar.gz
Epoch:          1

BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

BuildRequires: gcc, make, autoconf, automake, libtool
BuildRequires: pkgconfig, xmlto, zip
BuildRequires: %{?scl_prefix}apr-devel
BuildRequires: %{?scl_prefix}apr-util-devel
BuildRequires: %{?scl_prefix}httpd-devel
BuildRequires: %{?scl_prefix}openssl-devel
BuildRequires: %{?scl_prefix}jansson-devel
BuildRequires: %{?scl_prefix}libcurl-devel
BuildRequires: %{?scl_prefix}nghttp2-devel

BuildRequires: %{?scl_prefix}httpd
BuildRequires: %{?scl_prefix}openssl
BuildRequires: %{?scl_prefix}jansson
BuildRequires: %{?scl_prefix}libcurl
BuildRequires: %{?scl_prefix}nghttp2

Requires: %{?scl_prefix}httpd
Requires: %{?scl_prefix}apr
Requires: %{?scl_prefix}apr-util
Requires: %{?scl_prefix}openssl
Requires: %{?scl_prefix}jansson
Requires: %{?scl_prefix}libcurl
Requires: %{?scl_prefix}nghttp2

%description
This module manages common properties of domains for one or more
virtual hosts. Specifically it can use the ACME protocol to automate
certificate provisioning.  Certificates will be configured for managed
domains and their virtual hosts automatically, including at renewal.

%if %{with_src_zip}
%package src-zip
Summary:     Container for the source distribution of %{pkg_name}
Group:       Development

%description src-zip
Container for the source distribution of %{pkg_name}.
%endif

%prep
%setup -q -n %{pkg_name}-%{commitid}

# Rewrite release number
sed -i "s;-git;-%{serial};g" src/md_version.h.in

%build
autoreconf --force --install -I m4
automake
autoconf

%if %{with_src_zip}
zip -q -r %{name}-%{version}-src.zip *
%endif

export LDFLAGS="-L%{_libdir} -Wl,-rpath=%{_libdir} -Wl,-z,relro,-z,now"
export CFLAGS="-fPIC -g"
export CPPFLAGS="-I%{scldir}/usr/include"

./configure --with-apxs=%{_sbindir}/apxs \
    --with-jansson=%{scldir}/usr \
    --with-openssl=%{scldir}/usr \
    --with-curl=%{scldir}/usr

make %{?_smp_mflags} V=1

%install
%make_install

%if %{with_src_zip}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev
%{__install} %{name}-%{version}-src.zip  ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/%{name}-%{version}-src.zip
%endif

rm -rf %{buildroot}%{scldir}/etc/httpd/share/doc/
rm -rf %{buildroot}%{scldir}/etc/httpd/share/man/
%{__install} -d -m 0755 %{buildroot}%{_bindir}

# remove links and rename SO files
rm -f %{buildroot}%{_libdir}/httpd/modules/mod_md.so
mv %{buildroot}%{_libdir}/httpd/modules/mod_md.so.0.0.0 %{buildroot}%{_libdir}/httpd/modules/mod_md.so
mv %{buildroot}%{scldir}/etc/httpd/bin/a2md %{buildroot}%{_bindir}/a2md

# create configuration
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.modules.d
cat > %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/01-md.conf <<EOF
LoadModule md_module modules/mod_md.so
MDStoreDir %{scldir}/var/lib/httpd/md
EOF


%files
%doc README.md ChangeLog AUTHORS
%license LICENSE
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/01-md.conf
%{_libdir}/httpd/modules/mod_md.so
%{_bindir}/a2md

%if %{with_src_zip}
%files src-zip
%defattr(0644,root,root,0755)
%{_javadir}/jbossas-fordev/%{name}-%{version}-src.zip
%endif

%changelog
* Thu Oct 19 2023 Sokratis Zappis <szappis@redhat.com> - 2.4.0-26
- Rebuild for 2.4.57.SP1

* Wed Jun 21 2023 Mladen Turk <mturk@redhat.com> - 2.4.0-21
- Rebuild for httpd-2.4.57

* Wed May 10 2023 cpaas-ops <cpaas-ops@redhat.com> - 2.4.0-20
- Built by CPaaS

* Thu Apr 27 2023 Sokratis Zappis <szappis@redhat.com> - 2.4.0-19
- Build for JBCS httpd 2.4.51.SP2

* Wed Feb 16 2022 Mladen Turk <mturk@redhat.com> - 2.4.0-2
- Sync with lookaside repo

* Wed Feb 09 2022 Mladen Turk <mturk@redhat.com> - 2.4.0-1
- Use sources from rhel-9.0.0 branch

* Tue Dec 17 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.0.8-10
- JBCS 2.4.37-SP1.ER1

* Mon Dec 16 2019 Mladen Turk <mturk@redhat.com> - 1:2.0.8-9
- Rebuild for jbcs with updated commitid

* Tue Dec 10 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 2.0.8-8
- Creating src-zip rpm

* Wed Dec 04 2019 Mladen Turk <mturk@redhat.com> - 1:2.0.8-6
- Rebuild for jbcs

* Thu Oct 03 2019 Lubos Uhliarik <luhliari@redhat.com> - 1:2.0.8-5
- Resolves: #1747898 - add mod_md package

* Fri Aug 30 2019 Joe Orton <jorton@redhat.com> - 1:2.0.8-4
- require mod_ssl, update package description

* Fri Aug 30 2019 Joe Orton <jorton@redhat.com> - 1:2.0.8-3
- rebuild against 2.4.41

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1:2.0.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Jul 12 2019 Joe Orton <jorton@redhat.com> - 1:2.0.8-1
- update to 2.0.8

* Tue Jun 11 2019 Lubos Uhliarik <luhliari@redhat.com> - 2.0.3-1
- Initial import (#1719248).
